import sys
import re

# Legge da un file di testo, come se fosse una tabella sql
# la prima riga contiene il nome del campo
# dalla seconda in poi i valori separati da spazi
# creo una serie di generatori per fare ricerche e statistiche
# in stile sql sulle tabelle


# Restituisco un record come dictionary 
# leggendo da uno stream di righe di testo
def readTabbedText(l):
	header=l.next()
	listacampi=header.split()
	
#	print listacampi
	
	for linea in l:
		yield dict(zip(listacampi,linea.split()))


# restituisce solo le righe vuote	
def removeEmptyLine(l):
	for i in l:
		if len(i.strip())>0:
			yield i

# restituisce solo i valori di un campo
def selectField(l, campo):
	for i in l:
		yield i[campo]

# converte tutti le stringhe in numero int
def castInt(l):
	for i in l:
		yield int(i)

# restituisce solo i record, in cui il campo selezionato soddisfa
# il criterio indicato
def filterWhere(l,campo=None, valore=None, where=None):
	if where==None:
		where=lambda x: x[campo]==valore
	for i in l:
		if where(i):
			yield i

def stampa(l):
	for i in l:
		print i

# ---------------------------

l=readTabbedText(open('lista.txt'))
print "inizio ciclo"
for i in l:
	print i
	
print "inizio secondo ciclo"	
l=open('lista.txt')
l=removeEmptyLine(l)
l=readTabbedText(l)
l=selectField(l,'Saldo')
l=castInt(l)
print sum(l)

print "inizio secondo ciclo"	
l=open('lista.txt')
l=removeEmptyLine(l)
l=readTabbedText(l)
l=filterWhere(l, 'Nome', 'Mario')
l=selectField(l,'Saldo')
l=castInt(l)
print sum(l)

